#include <bits/stdc++.h>
using namespace std;

typedef long long LL;
typedef unsigned long long ULL;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

const int N = 2e5 + 7;
const int L = 10;
const int B = 7;

int n, q;
unordered_map < ULL, pair < int, ULL > > counters[L + 1];
unordered_map < ULL, vector < ULL > > words[L + 1];
ULL tmp_masks[L + 1][1 << L];

ULL convert_to_mask(string &s)
{
    ULL mask = 0;
    for(int i = 0; i < sz(s); i++)
    {
        ULL x = (s[i] == '?' ? 0 : s[i] - 'a' + 1);
        mask |= (x << (5 * i));
    }
    return mask;
}

string convert_to_string(ULL &mask, int len)
{
    string s;
    s.resize(len);
    for(int i = 0; i < len; i++)
    {
        ULL x = (mask >> (5 * i)) & 31;
        s[i] = (x ? x + 'a' - 1 : '?');
    }
    return s;
}

bool matches(ULL &p, ULL &m, ULL &s)
{
    return p == (m & s);
}

void preapre_masks()
{
    for(int i = 1; i <= L; i++)
    {
        for(int j = 0; j < (1 << i); j++)
        {
            for(int k = 0; k < i; k++)
            {
                if((j >> k) & 1)
                {
                    tmp_masks[i][j] |= (31LL << (5 * k));
                }
            }
        }
    }
}

void update_short(ULL &s, int l, int mask)
{
    ULL tmp = s & tmp_masks[l][mask];
    int t = counters[l][tmp].first;
    counters[l][tmp] = {t + 1, s};
}

void update_long(ULL &s, int l, int mask)
{
    ULL tmp = s & tmp_masks[l][mask];
    int t = counters[l][tmp].first;
    counters[l][tmp] = {t + 1, s};
    words[l][tmp].push_back(s);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    preapre_masks();

    cin >> n;
    while(n--)
    {
        string s; cin >> s;
        ULL mask = convert_to_mask(s);
        int l = sz(s);

        if(l <= B)
        {
            for(int i = 0; i < (1 << l); i++)
                update_short(mask, l, i);
        }
        else
        {
            update_long(mask, l, 0);

            for(int i = 0; i < l; i++)
            {
                update_long(mask, l, (1 << i));

                for(int j = i + 1; j < l; j++)
                {
                    update_long(mask, l, (1 << i) | (1 << j));

                    for(int k = j + 1; k < l; k++)
                        update_long(mask, l, (1 << i) | (1 << j) | (1 << k));
                }
            }
        }
    }

    int nonzero = 0, exact = 0;

    cin >> q;
    cerr << "q = " << q;
    while(q--)
    {
        string s; cin >> s;
        ULL mask = convert_to_mask(s);
        int l = sz(s);

        if(l <= B)
        {
            auto it = counters[l].find(mask);

            if(it == counters[l].end())
            {
                cout << 0 << "\n";
            }
            else if(it->second.first != 1)
            {
                nonzero++;
                cout << it->second.first << "\n";
            }
            else
            {
                nonzero++;
                exact++;
                cout << convert_to_string(it->second.second, l) << "\n";
            }
        }
        else
        {
            int known = 0;
            vector < int > pos;
            for(int i = 0; i < l; i++)
            {
                if(s[i] != '?')
                {
                    known++;
                    pos.push_back(i);
                }
            }

            if(known <= 3)
            {
                auto it = counters[l].find(mask);

                if(it == counters[l].end())
                {
                    cout << 0 << "\n";
                }
                else if(it->second.first != 1)
                {
                    nonzero++;
                    cout << it->second.first << "\n";
                }
                else
                {
                    nonzero++;
                    exact++;
                    cout << convert_to_string(it->second.second, l) << "\n";
                }
            }
            else
            {
                ULL best_mask = 0;
                int how_many = N;

                for(int i = 0; i < sz(pos); i++)
                {
                    for(int j = i + 1; j < sz(pos); j++)
                    {
                        for(int k = j + 1; k < sz(pos); k++)
                        {
                            ULL tmp = mask & tmp_masks[l][(1 << pos[i]) | (1 << pos[j]) | (1 << pos[k])];

                            auto it = counters[l].find(tmp);

                            if(it != counters[l].end() && it->second.first < how_many)
                            {
                                how_many = it->second.first;
                                best_mask = tmp;
                            }
                        }
                    }
                }

                if(how_many == N)
                    cout << 0 << "\n";
                else
                {
                    vector < ULL > v = words[l][best_mask];
                    int ans = 0;
                    ULL some = 0;

                    int tmp = 0;
                    for(int i = 0; i < l; i++)
                        if(s[i] != '?') tmp |= (1 << i);
                    ULL query_mask = tmp_masks[l][tmp];

                    for(auto can: v)
                    {
                        if(matches(mask, query_mask, can))
                        {
                            ans++;
                            some = can;
                        }
                    }

                    if(ans > 0)
                        nonzero++;
                    if(ans == 1)
                        exact++;

                    if(ans != 1)
                        cout << ans << "\n";
                    else
                        cout << convert_to_string(some, l) << "\n";
                }
            }
        }
    }
    return 0;
}
